unit FmaObj;
/////////////////////////////////////////////////////////////////////////////
//
// Fidonet Mail Access: Interface file for static linking in Delphi
//
// FmaObj.pas
//
// Copyright (c) 1999-2000 by Pete Kvitek
// Convertion to Delphi's Object Pascal by Eugene Kotlyarov
//                                         http://ekot.narod.ru/fma/
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version. See GNU_GPL.TXT for details.
//
// Created: 13/Jan/2001
// Updated: 15/Feb/2001
//
// History: 13/Jan/2001 eugene  - Initially created
//          15/Feb/2001 akzhan  - Updated.
//
/////////////////////////////////////////////////////////////////////////////

{$I FmxDef.inc}

{$IFDEF FMA_STATIC_LINKAGE}
  {$L FtsArea.obj}
  {$L FtsApi.obj}
  {$L FtsCheck.obj}
  {$L FtsLast.obj}
  {$L FtsMsg.obj}
  {$L FtsRead.obj}
  {$L FtsWrite.obj}

  {$L PktApi.obj}
  {$L PktArea.obj}
  {$L PktCheck.obj}
  {$L PktHelp.obj}
  {$L PktLast.obj}
  {$L PktLock.obj}
  {$L PktMsg.obj}
  {$L PktRead.obj}
  {$L PktWrite.obj}

  {$L JamApi.obj}
  {$L JamArea.obj}
  {$L JamCheck.obj}
  {$L JamHelp.obj}
  {$L JamIndex.obj}
  {$L JamLast.obj}
  {$L JamLock.obj}
  {$L JamMsg.obj}
  {$L JamRead.obj}
  {$L JamWrite.obj}

  {$L SquApi.obj}
  {$L SquArea.obj}
  {$L SquCheck.obj}
  {$L SquHelp.obj}
  {$L SquIndex.obj}
  {$L SquLast.obj}
  {$L SquLock.obj}
  {$L SquMsg.obj}
  {$L SquRead.obj}
  {$L SquWrite.obj}

  {$L FmaApi.obj}
  {$L FmaCRC32.obj}
  {$L FmaCtrl.obj}
  {$L FmaFmm.obj}
  {$L FmaDsz.obj}
  {$L FmaDTTM.obj}
  {$L FmaFmt.obj}
  {$L FmaInit.obj}
  {$L FmaList.obj}
  {$L FmaLsz.obj}
  {$L FmaSys.obj}
  {$L FmaUti.obj}

  {$IFDEF VIRTUALPASCAL}
    {$L crtdll.lib}  // vp linker traps :(
  {$ENDIF}
{$ENDIF}
interface

{$IFDEF FMA_STATIC_LINKAGE}

uses Windows, FmaApi, FmaDef, FmaUti, FmaCtrl, FmaSys,
	PktApi, PktApiP,
	FtsApi, FtsApiP,
	JamApi, JamApiP,
	SquApi, SquApiP;

//////////////////////////////////////////////////////////////////////////////
//  FMAAPI
//////////////////////////////////////////////////////////////////////////////

function FmaCreateMsg(cbExtra: UINT): PFMM;
  stdcall;
function FmaDestroyMsg(pfmm: PFMM): BOOL;
  stdcall;
function FmaDupeMsg(pfmm: PFMM): PFMM;
  stdcall;
function FmaDumpMsg(pfmm: PFMM): BOOL; 
  stdcall;

function FmaGetFmp(pfmm: PFMM; id: ULONG; ifmp: UINT): PFMP;
  stdcall;
function FmaDelFmp(pfmm: PFMM; id: ULONG; ifmp: UINT): BOOL;
  stdcall;
function FmaDumpFmp(pfmp: PFMP): BOOL;
  stdcall;
function FmaAddFmp(pfmm: PFMM; id: ULONG; pbData: Pointer; cbData: ULONG): PFMP;
  stdcall;
function FmaAddFmpFormatV(pfmm: PFMM; id: ULONG; pszFormat: PAnsiChar; parg: Tva_list): PFMP;
  stdcall;
function FmaGetFmpTextLen(pfmp: PFMP): ULONG;
  stdcall;

function FmaOpenArea(pszPath: PAnsiChar; _type: UINT; fOpenMode: UINT; fl: ULONG; var pnetAddr: NETADDR): TAreaHandle;
  stdcall;

function FmaCloseArea(harea: TAreaHandle): BOOL;
  stdcall;
function FmaLockArea(harea: TAreaHandle; bLock: BOOL): BOOL;
  stdcall;

function FmaValidateMsg(harea: TAreaHandle; msgn: TMsgNumber; pimsg: PULONG): BOOL;
  stdcall;
function FmaCreateMsgMap(harea: TAreaHandle; var paumsg: PUMSG; var pcumsg: ULONG): BOOL; 
  stdcall;
function FmaEnumMsgs(harea: TAreaHandle; pfnCallback: PFNENUMMSGS; pvCallbackData: Pointer; fl: ULONG): BOOL;
  stdcall;

function FmaDeleteMsg(harea: TAreaHandle; msgn: TMsgNumber): BOOL;
  stdcall;
function FmaSetCurMsg(harea: TAreaHandle; msgn: TMsgNumber): BOOL; 
  stdcall;
function FmaGetCurMsg(harea: TAreaHandle): TMsgNumber; 
  stdcall;
function FmaGetFirstMsg(harea: TAreaHandle): TMsgNumber;
  stdcall;
function FmaGetHighMsg(harea: TAreaHandle): TMsgNumber; 
  stdcall;
function FmaGetMsgCount(harea: TAreaHandle): LONG; 
  stdcall;

function FmaMsgnToUid(harea: TAreaHandle; msgn: TMsgNumber): UMSG; 
  stdcall;
function FmaUidToMsgn(harea: TAreaHandle; umsg: UMSG; fMode: UINT): TMsgNumber; 
  stdcall;

function FmaOpenMsg(harea: TAreaHandle; mode: UINT; msgn: TMsgNumber; fl: ULONG): TMsgHandle; 
  stdcall;
function FmaCloseMsg(hmsg: TMsgHandle): BOOL; 
  stdcall;

function FmaLoadMsg(hmsg: TMsgHandle; var ppfmm: PFMM; fl: ULONG): BOOL; 
  stdcall;
function FmaSaveMsg(hmsg: TMsgHandle; pfmm: PFMM; fl: ULONG; cchTextTotal: ULONG): BOOL; 
  stdcall;

function FmaReadMsg(hmsg: TMsgHandle; pmsgh: Pointer; var ppchCtrl: Pointer; pcchCtrl: PULONG;
  var ppchText: PAnsiChar; pcchText: PULONG; poffText: PULONG): BOOL;
  stdcall;

function FmaWriteMsg(hmsg: TMsgHandle; pmsgh: Pointer; pchCtrl: Pointer; cchCtrl: ULONG;
  pchText: PAnsiChar; cchText: ULONG; poffText: PULONG; cchTextTotal: ULONG): BOOL; 
  stdcall;

function FmaGetMsgCtrlLen(hmsg: TMsgHandle; var pcchCtrl: ULONG): BOOL; 
  stdcall;
function FmaGetMsgTextLen(hmsg: TMsgHandle; var pcchText: ULONG): BOOL; 
  stdcall;

function FmaGetLRInfo(harea: TAreaHandle; uid: ULONG; plri: PLRINFO): BOOL; 
  stdcall;
function FmaSetLRInfo(harea: TAreaHandle; uid: ULONG; plri: PLRINFO; pszUserName: PAnsiChar): BOOL; 
  stdcall;

function FmaRegisterApi(_type: UINT; pfnGetApi: TFmaGetApi): BOOL; 
  stdcall;

function FmaInitialize(pfmaInit: PFMAINIT): BOOL; 
  stdcall;
function FmaTerminate: BOOL; 
  stdcall;
function FmaGetVersion(var pfmaVer: FMAVER): BOOL; 
  stdcall;

function FmaSetLastError(code: TFmaError): TFmaError;
  stdcall;
function FmaGetLastError: TFmaError; 
  stdcall;

//////////////////////////////////////////////////////////////////////////////
//  FTSAPI
//////////////////////////////////////////////////////////////////////////////

function FtsGetApi: PAPI; stdcall;

function FtsOpenArea(pszPath: PAnsiChar; fOpenMode: UINT; fl: ULONG; var pnetAddr: NETADDR): TAreaHandle;
  stdcall;

function FtsCloseArea(harea: TAreaHandle): BOOL; stdcall;
function FtsLockArea(harea: TAreaHandle; bLock: BOOL): BOOL; stdcall;

function FtsValidateMsg(harea: TAreaHandle; msgn: TMsgNumber; pimsg: PULONG): BOOL;
  stdcall;
function FtsCreateMsgMap(harea: TAreaHandle; var paumsg: PUMSG; var pcumsg: ULONG): BOOL; 
  stdcall;
function FtsEnumMsgs(harea: TAreaHandle; pfnCallback: PFNENUMMSGS; pvCallbackData: Pointer; fl: ULONG): BOOL; 
  stdcall;

function FtsDeleteMsg(harea: TAreaHandle; msgn: TMsgNumber): BOOL; 
  stdcall;
function FtsSetCurMsg(harea: TAreaHandle; msgn: TMsgNumber): BOOL; 
  stdcall;
function FtsGetCurMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function FtsGetFirstMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function FtsGetHighMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function FtsGetMsgCount(harea: TAreaHandle): LONG; stdcall;

function FtsMsgnToUid(harea: TAreaHandle; msgn: TMsgNumber): UMSG; stdcall;
function FtsUidToMsgn(harea: TAreaHandle; umsg: UMSG; fMode: UINT): TMsgNumber; 
  stdcall;

function FtsOpenMsg(harea: TAreaHandle; mode: UINT; msgn: TMsgNumber; fl: ULONG): TMsgHandle;
  stdcall;
function FtsCloseMsg(hmsg: TMsgHandle): BOOL; 
  stdcall;

function FtsLoadMsg(hmsg: TMsgHandle; var ppfmm: PFMM; fl: ULONG): BOOL; 
  stdcall;
function FtsSaveMsg(hmsg: TMsgHandle; pfmm: PFMM; fl: ULONG; cchTextTotal: ULONG): BOOL; 
  stdcall;

function FtsReadMsg(hmsg: TMsgHandle; pfmh: PFMH; var ppchCtrl: PAnsiChar; pcchCtrl: PULONG;
  var ppchText: PAnsiChar; pcchText: PULONG; poffText: PULONG): BOOL; 
  stdcall;

function FtsWriteMsg(hmsg: TMsgHandle; pfmh: PFMH; pchCtrl: PAnsiChar; cchCtrl: ULONG;
  pchText: PAnsiChar; cchText: ULONG; poffText: PULONG; cchTextTotal: ULONG): BOOL; 
  stdcall;

function FtsGetMsgCtrlLen(hmsg: TMsgHandle; var pcchCtrl: ULONG): BOOL;
  stdcall;
function FtsGetMsgTextLen(hmsg: TMsgHandle; var pcchText: ULONG): BOOL;
  stdcall;

function FtsGetLRInfo(harea: TAreaHandle; uid: ULONG; plri: PLRINFO): BOOL;
  stdcall;
function FtsSetLRInfo(harea: TAreaHandle; uid: ULONG; plri: PLRINFO; pszUserName: PChar): BOOL;
  stdcall;

//////////////////////////////////////////////////////////////////////////////
//  FTSAPIP
//////////////////////////////////////////////////////////////////////////////

function FtsCheckArea(parea:PFAREA):BOOL;stdcall;
function FtsCheckMsg(pmsg:PFMSG):BOOL; stdcall;
function FtsSortMsgMap(parea:PFAREA):BOOL; stdcall;
function FtsRescanArea(parea:PFAREA):BOOL; stdcall;
function FtsAddMsg(parea:PFAREA;msgn:TMsgNumber):BOOL; stdcall;
function FtsCheckBase(pszPath:PSZ):BOOL; stdcall;

//////////////////////////////////////////////////////////////////////////////
//  PKTAPI
//////////////////////////////////////////////////////////////////////////////

function PktGetApi: PAPI; stdcall;

function PktOpenArea(pszPath: PAnsiChar; fOpenMode: UINT; fl: ULONG; var pnetAddr: NETADDR): TAreaHandle; stdcall;

function PktCloseArea(harea: TAreaHandle): BOOL; stdcall;
function PktLockArea(harea: TAreaHandle; bLock: BOOL): BOOL; stdcall;

function PktValidateMsg(harea: TAreaHandle; msgn: TMsgNumber; pimsg: PULONG): BOOL; stdcall;
function PktCreateMsgMap(harea: TAreaHandle; var paumsg: PUMSG; var pcumsg: ULONG): BOOL; stdcall;
function PktEnumMsgs(harea: TAreaHandle; pfnCallback: PFNENUMMSGS; pvCallbackData: Pointer; fl: ULONG): BOOL; stdcall;

function PktDeleteMsg(harea: TAreaHandle; msgn: TMsgNumber): BOOL; stdcall;
function PktSetCurMsg(harea: TAreaHandle; msgn: TMsgNumber): BOOL; stdcall;
function PktGetCurMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function PktGetFirstMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function PktGetHighMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function PktGetMsgCount(harea: TAreaHandle): LONG; stdcall;

function PktMsgnToUid(harea: TAreaHandle; msgn: TMsgNumber): UMSG; stdcall;
function PktUidToMsgn(harea: TAreaHandle; umsg: UMSG; fMode: UINT): TMsgNumber; stdcall;

function PktOpenMsg(harea: TAreaHandle; mode: UINT; msgn: TMsgNumber; fl: ULONG): TMsgHandle; stdcall;
function PktCloseMsg(hmsg: TMsgHandle): BOOL; stdcall;

function PktLoadMsg(hmsg: TMsgHandle; var ppfmm: PFMM; fl: ULONG): BOOL; stdcall;
function PktSaveMsg(hmsg: TMsgHandle; pfmm: PFMM; fl: ULONG; cchTextTotal: ULONG): BOOL; stdcall;

function PktReadMsg(hmsg: TMsgHandle; pfmh: PFMH; var ppchCtrl: PAnsiChar; pcchCtrl: PULONG;
  var ppchText: PAnsiChar; pcchText: PULONG; poffText: PULONG): BOOL; stdcall;

function PktWriteMsg(hmsg: TMsgHandle; pfmh: PFMH; pchCtrl: PAnsiChar; cchCtrl: ULONG;
  pchText: PAnsiChar; cchText: ULONG; poffText: PULONG; cchTextTotal: ULONG): BOOL; stdcall;

function PktGetMsgCtrlLen(hmsg: TMsgHandle; var pcchCtrl: ULONG): BOOL; stdcall;
function PktGetMsgTextLen(hmsg: TMsgHandle; var pcchText: ULONG): BOOL; stdcall;

function PktGetLRInfo(harea: TAreaHandle; uid: ULONG; plri: PLRINFO): BOOL; stdcall;
function PktSetLRInfo(harea: TAreaHandle; uid: ULONG; plri: PLRINFO; pszUserName: PAnsiChar): BOOL; stdcall;

//////////////////////////////////////////////////////////////////////////////
//  PKTAPIP
//////////////////////////////////////////////////////////////////////////////

function PktCheckArea(parea:PPAREA):BOOL;
	stdcall;
function PktCheckMsg(pmsg:PPMSG):BOOL;
	stdcall;
function PktCheckMsgReadMode(pmsg:PPMSG):BOOL;
	stdcall;
function PktCheckMsgWriteMode(pmsg:PPMSG):BOOL;
	stdcall;

function PktLockBase(parea:PPAREA; bLock:BOOL):BOOL;
	stdcall;
function PktEnterExclusive(parea:PPAREA):BOOL;
	stdcall;
function PktLeaveExclusive(parea:PPAREA):BOOL;
	stdcall;
function PktSetEnd(parea:PPAREA; offs:LONG):BOOL;
	stdcall;
function PktRescanArea(parea:PPAREA):BOOL;
	stdcall;

function PktLoadPbh(parea:PPAREA):BOOL;
	stdcall;
function PktSavePbh(parea:PPAREA):BOOL;
	stdcall;
function PktCheckPbh(parea:PPAREA):BOOL;
	stdcall;

function PktResetCurMsgCache(parea:PPAREA):BOOL;
	stdcall;
function PktSetCurMsgCache(pmsg:PPMSG):BOOL;
	stdcall;

function PktGetOpenMsg(parea:PPAREA; msgn:TMsgNumber):PPMSG;
    stdcall;
function PktLoadPmh(parea:PPAREA; pfmh:PFMH; lmh:LONG):BOOL;
	stdcall;
function PktSavePmh(parea:PPAREA; pfmh:PFMH; lmh:LONG):BOOL;
	stdcall;

function PktAddMsg(parea:PPAREA; lmh:LONG; cbHdr,cbMsg:ULONG):BOOL;
	stdcall;
function PktDelMsg(parea:PPAREA; imsg:UINT):BOOL;
	stdcall;
function PktShrinkPkt(parea:PPAREA; offs:LONG; cb:ULONG):BOOL;
	stdcall;
function PktExpandPkt(parea:PPAREA; offs:LONG; cb:ULONG):BOOL;
	stdcall;

function PktCheckBase(pszPath:PSZ):BOOL;
	stdcall;

function PktSetNetAddr(parea:PPAREA; var pnetOrig, pnetDest:NETADDR):BOOL;
	stdcall;
function PktGetNetAddr(parea:PPAREA; var pnetOrig, pnetDest:NETADDR):BOOL;
	stdcall;

function PktSetPassword(parea:PPAREA; pszPassword:PSZ):BOOL;
	stdcall;
function PktCheckPassword(parea:PPAREA; pszPassword:PSZ):BOOL;
	stdcall;

//////////////////////////////////////////////////////////////////////////////
//  FMAUTI
//////////////////////////////////////////////////////////////////////////////

function FmaListAdd(var pple: PLST_ENTRY; ple: PLST_ENTRY; ile: UINT): UINT;
  stdcall;
function FmaListDel(var pple: PLST_ENTRY; ile: UINT): PLST_ENTRY;
  stdcall;
function FmaListCount(ple: PLST_ENTRY): UINT;
  stdcall;

function FmaSkipSpaces(var ppch: PAnsiChar): AnsiChar;
  stdcall;
function FmaTrimSpaces(var ppch: PAnsiChar): AnsiChar;
  stdcall;
function FmaAllocString(var ppsz: PAnsiChar; pch: PAnsiChar; cch: UINT): PAnsiChar;
  stdcall;
function FmaEqPsz(psz1, psz2: PAnsiChar): BOOL;
  stdcall;
function FmaEqPch(pch1, pch2: PAnsiChar; cch: UINT): BOOL;
  stdcall;
function FmaCpyStrMax(pchTo, pchFrom: PAnsiChar; cchMax: UINT): UINT;
  stdcall;
function FmaGetHash(psz: PAnsiChar): ULONG;
  stdcall;
function FmaGetCrc32(pb: PBYTE; cb: ULONG; crc: ULONG; bLowerCase: BOOL): ULONG;
  stdcall;
function FmaGetCrc32v(var v; cb: ULONG; crc: ULONG; bLowerCase: BOOL): ULONG;
  stdcall;

function FmaAddLsz(var pplsz: PLSZ; pch: PAnsiChar; cch: UINT; ilsz: UINT): PLSZ;
  stdcall;
function FmaGetLsz(plsz: PLSZ; psz: PAnsiChar): PLSZ;
  stdcall;
function FmaDelLsz(var pplsz: PLSZ; ilsz: UINT): BOOL;
  stdcall;
procedure FmaDelLszList(var pplsz: PLSZ);
  stdcall;

function FmaAddDsz(pdsz: PDSZ; pch: PAnsiChar; cch: UINT): BOOL;
  stdcall;
function FmaAddDszFormatV(pdsz: PDSZ; pszFormat: PAnsiChar; parg: Tva_list): BOOL;
  stdcall;
function FmaSetDsz(pdsz: PDSZ; pch: PAnsiChar; cch: UINT): BOOL;
  stdcall;
function FmaSetDszFormatV(pdsz: PDSZ; pszFormat: PAnsiChar; parg: Tva_list): BOOL;
  stdcall;
function FmaFixDsz(pdsz: PDSZ): BOOL;
  stdcall;
procedure FmaDelDsz(pdsz: PDSZ);
  stdcall;

function FmaScanNetAddr(var pnetAddr: NETADDR; psz: PAnsiChar): PAnsiChar;
  stdcall;
function FmaFormatNetAddr(pch: PAnsiChar; cchMax: UINT; const pnetAddr: NETADDR;
							  pszDomain: PAnsiChar): UINT;
  stdcall;

function FmaFormatDttm(pchDttm:PAnsiChar;cchMax:UINT; dttm:PDTTM; fl:ULONG;
						 chDateSep:Char;chTimeSep:char;
						 pszDateTimeSep:PAnsiChar):UINT; 
  stdcall;
//////////////////////////////////////////////////////////////////////////////
function FmaGetNetAddr(pfmm: PFMM; id: ULONG; var pnetAddr: NETADDR;
              var ppchDomain: PAnsiChar): BOOL; stdcall;

function FmaLoadMhdr(pfmm: PFMM; pmhdr: Pointer; aMhdr: PMHDRMAP; nMhdr: UINT): BOOL; stdcall;
function FmaSaveMhdr(pfmm: PFMM; pmhdr: Pointer; aMhdr: PMHDRMAP; nMhdr: UINT): BOOL; stdcall;

function FmaLoadFLAGS(pfmm: PFMM; pchData: PAnsiChar; cchData: UINT): BOOL; stdcall;

function FmaLoadKludge(pfmm: PFMM; pch: PAnsiChar; cch: UINT; var pkli: KLI): BOOL; stdcall;
function FmaSaveKludge(pfmm: PFMM; pfmp: PFMP; pdszCtrl: PDSZ; bAddCR: BOOL): BOOL; stdcall;

function FmaLoadAddrKludges(pfmm: PFMM; var pkli: PKLI; var pnetOrig: NETADDR;
                 var pnetDest: NETADDR; var pnetDefault: NETADDR;
                 bEchoMail: BOOL): BOOL; stdcall;

function FmaSaveAddrKludges(pfmm: PFMM; pdszCtrl: PDSZ; var pnetOrig: NETADDR;
                 var pnetDest: NETADDR; var pnetDefault: NETADDR;
                 bNoMhdrZoneInfo: BOOL; bNoMhdrPointInfo: BOOL;
                 fl: ULONG; bAddCR: BOOL): BOOL; stdcall;

function FmaLoadEomKludges(pfmm: PFMM; fl: ULONG): BOOL; stdcall;
function FmaSaveEomKludges(pfmm: PFMM; pdszEom: PDSZ): BOOL; stdcall;

function FmaGetFlagFromAttr(attr: ULONG): PAnsiChar; stdcall;
function FmaGetAttrFromFlag(pch: PAnsiChar; cch: UINT): ULONG; stdcall;

function FmaGetKludgeFromId(id: ULONG): PKLMAP; stdcall;
function FmaGetKludgeFromString(pch: PAnsiChar; cch: UINT): PKLMAP; stdcall;

function FmaGetEomKludgeFromId(id: ULONG): PKLMAP; stdcall;
function FmaGetEomKludgeFromString(pch: PAnsiChar; cch: UINT; bHasPrefix: BOOL): PKLMAP; stdcall;

function FmaAddAutoMSGID(pfmm: PFMM): PFMP; stdcall;
function FmaAddAutoPID(pfmm: PFMM): PFMP; stdcall;
function FmaAddAutoProp(pfmm: PFMM; fl: ULONG): BOOL; stdcall;

//////////////////////////////////////////////////////////////////////////////
//  FMASYS
//////////////////////////////////////////////////////////////////////////////
function FmaMemAlloc(cb: Integer; bZero: BOOL): Pointer; stdcall;
function FmaMemRealloc(p: Pointer; cb: Integer): Pointer; stdcall;
procedure FmaMemFree(p: Pointer); stdcall;
function FmaOpenFile(pszFile: PChar; fOpen: UINT; var phfile: TFmaFile): BOOL; stdcall;
function FmaCloseFile(var phfile: TFmaFile): BOOL; stdcall;
function FmaReadFile(hfile: TFmaFile; offs: LONG; pb: Pointer; cb: ULONG; var pcbRead: ULONG): BOOL; stdcall;
function FmaWriteFile(hfile: TFmaFile; offs: LONG; pb: Pointer; cb: ULONG; var pcbWritten: ULONG): BOOL; stdcall;

function FmaGetFilePos(hfile: TFmaFile): LONG;
function FmaSetFilePos(hfile: TFmaFile; offs: LONG): LONG;
function FmaGetFileSize(hfile: TFmaFile): LONG; stdcall;
function FmaSetFileSize(hfile: TFmaFile; cbFile: ULONG): BOOL; stdcall;
function FmaLock(hfile: TFmaFile; offset: LONG; cb: LONG; bLock: BOOL): BOOL; stdcall;
function FmaDeleteFile(pszFile: PChar): BOOL; stdcall;
function FmaEnumFiles(pszPath: PChar; pszMask: PChar; pfnCallback: PFNENUMFILES;
  pvCallbackData: Pointer; fl: ULONG): BOOL; stdcall;

function FmaFileExists(pszPath: PChar): BOOL; stdcall;
function FmaDirExists(pszPath: PChar): BOOL; stdcall;
function FmaMakeDir(pszPath: PChar): BOOL; stdcall;
procedure FmaInterlockedIncrement(var plv: LONG); stdcall;
procedure FmaInterlockedDecrement(var plv: LONG); stdcall;
function FmaGetLocalDttm(var pdttm: DTTM): BOOL; stdcall;
function FmaGetLocalTime: ULONG; stdcall;
procedure FmaSleep(milliseconds: ULONG); stdcall;
function FmaGetMsgIdStamp: ULONG; stdcall;
function FmaQueryOSType: UINT; stdcall;
procedure FmaGiveOutTimeSlice; stdcall;
//////////////////////////////////////////////////////////////////////////////
//  JAMAPI
//////////////////////////////////////////////////////////////////////////////
function JamGetApi: PAPI; stdcall;

function JamOpenArea(pszPath: PAnsiChar; fOpenMode: UINT; fl: ULONG; var pnetAddr: NETADDR): TAreaHandle; stdcall;

function JamCloseArea(harea: TAreaHandle): BOOL; stdcall;
function JamLockArea(harea: TAreaHandle; bLock: BOOL): BOOL; stdcall;

function JamValidateMsg(harea: TAreaHandle; msgn: TMsgNumber; pimsg: PULONG): BOOL; stdcall;
function JamCreateMsgMap(harea: TAreaHandle; var paumsg: PUMSG; var pcumsg: ULONG): BOOL; stdcall;
function JamEnumMsgs(harea: TAreaHandle; pfnCallback: PFNENUMMSGS; pvCallbackData: Pointer; fl: ULONG): BOOL; stdcall;

function JamDeleteMsg(harea: TAreaHandle; msgn: TMsgNumber): BOOL; stdcall;
function JamSetCurMsg(harea: TAreaHandle; msgn: TMsgNumber): BOOL; stdcall;
function JamGetCurMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function JamGetFirstMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function JamGetHighMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function JamGetMsgCount(harea: TAreaHandle): LONG; stdcall;

function JamMsgnToUid(harea: TAreaHandle; msgn: TMsgNumber): UMSG; stdcall;
function JamUidToMsgn(harea: TAreaHandle; umsg: UMSG; fMode: UINT): TMsgNumber; stdcall;

function JamOpenMsg(harea: TAreaHandle; mode: UINT; msgn: TMsgNumber; fl: ULONG): TMsgHandle; stdcall;
function JamCloseMsg(hmsg: TMsgHandle): BOOL; stdcall;

function JamLoadMsg(hmsg: TMsgHandle; var ppfmm: PFMM; fl: ULONG): BOOL; stdcall;
function JamSaveMsg(hmsg: TMsgHandle; pfmm: PFMM; fl: ULONG; cchTextTotal: ULONG): BOOL; stdcall;

function JamReadMsg(hmsg: TMsgHandle; pjmh: PJMH; var ppjsf: PJSF; pcbjsf: PULONG;
  var ppchText: PAnsiChar; pcchText: PULONG; poffText: PULONG): BOOL; stdcall;

function JamWriteMsg(hmsg: TMsgHandle; pjmh: PJMH; pjsf: PJSF; cbjsf: ULONG;
  pchText: PAnsiChar; cchText: ULONG; poffText: PULONG; cchTextTotal: ULONG): BOOL; stdcall;

function JamGetMsgCtrlLen(hmsg: TMsgHandle; var pcchCtrl: ULONG): BOOL; stdcall;
function JamGetMsgTextLen(hmsg: TMsgHandle; var pcchText: ULONG): BOOL; stdcall;

function JamGetLRInfo(harea: TAreaHandle; uid: ULONG; plri: PLRINFO): BOOL; stdcall;
function JamSetLRInfo(harea: TAreaHandle; uid: ULONG; plri: PLRINFO; pszUserName: PAnsiChar): BOOL; stdcall;
//////////////////////////////////////////////////////////////////////////////
//  JAMAPIP
//////////////////////////////////////////////////////////////////////////////
function JamCheckArea(parea:PJAREA):BOOL;
    stdcall;
function JamCheckMsg(pmsg:PJMSG):BOOL;
    stdcall;
function JamCheckMsgReadMode(pmsg:PJMSG):BOOL;
    stdcall;
function JamCheckMsgWriteMode(pmsg:PJMSG):BOOL;
    stdcall;

function JamLockBase(parea:PJAREA; bLock:BOOL):BOOL;
    stdcall;
function JamEnterExclusive(parea:PJAREA):BOOL;
    stdcall;
function JamLeaveExclusive(parea:PJAREA):BOOL;
    stdcall;

function JamLoadJbh(parea:PJAREA):BOOL;
    stdcall;
function JamSaveJbh(parea:PJAREA):BOOL;
    stdcall;
function JamCheckJbh(parea:PJAREA):BOOL;
    stdcall;

function JamResetCurMsgCache(parea:PJAREA):BOOL;
    stdcall;
function JamSetCurMsgCache(pmsg:PJMSG):BOOL;
    stdcall;

function JamGetOpenMsg(parea:PJAREA; msgn:TMsgNumber):PJMSG;
    stdcall;

function JamCheckLmh(parea:PJAREA; lmh:LONG):BOOL;
    stdcall;
function JamLoadJmh(parea:PJAREA; pjmh:PJMH; var ppjsf:PJSF; lmh:LONG):BOOL;
    stdcall;
function JamSaveJmh(parea:PJAREA; pjmh:PJMH; pjsf:PJSF; lmh:LONG):BOOL;
    stdcall;

function JamGetJsf(pjsf:PJSF; cbjsf:ULONG; id:USHORT; jsfIndex:LONG):PJSF;
    stdcall;
function JamDelJsf(var ppjsf:PJSF; var pcbjsf:ULONG; id:USHORT):BOOL;
    stdcall;
function JamAddJsf(var ppjsf:PJSF; var pcbjsf:ULONG; id:USHORT; pb:PVOID; cb:ULONG):PJSF;
    stdcall;
//function _JamAddJsfFormat(var ppjsf:PJSF; var pcbjsf:ULONG; id:USHORT; pszFormat:PSZ{, ...}):PJSF;cdecl;
function JamAddJsfFormatV(var ppjsf:PJSF; var pcbjsf:ULONG; id:USHORT; pszFormat:PSZ; parg:va_list):PJSF;
    stdcall;

function JamBeginJdxCache(parea:PJAREA):BOOL;
    stdcall;
function JamEndJdxCache(parea:PJAREA):BOOL;
    stdcall;
function JamGetJdxCount(parea:PJAREA):ULONG;
    stdcall;
function JamGetJdx(parea:PJAREA; pjdx:PJDX; msgn:TMsgNumber):BOOL;
    stdcall;
function JamSetJdx(parea:PJAREA; pjdx:PJDX; msgn:TmsgNumber):BOOL;
    stdcall;
function JamDelJdx(parea:PJAREA; pjdx:PJDX; msgn:TMsgNumber):BOOL;
    stdcall;
function JamAddJdx(parea:PJAREA; pjdx:PJDX; var pmsgn:TMsgNumber):BOOL;
    stdcall;

function JamGetCrc32(pch:PCH; cch:ULONG; crc:ULONG):ULONG;
    stdcall;

function JamGetJlr(parea:PJAREA; uid:ULONG; pjlr:PJLR; var poffs:LONG):BOOL;
    stdcall;
function JamSetJlr(parea:PJAREA; pjlr:PJLR):BOOL;
    stdcall;

function JamCheckBase(pszPath:PSZ):BOOL;
    stdcall;
function JamSetPassword(parea:PJAREA; pszPassword:PSZ):BOOL;
    stdcall;
function JamCheckPassword(parea:PJAREA; pszPassword:PSZ):BOOL;
    stdcall;
//////////////////////////////////////////////////////////////////////////////
//  SQUAPI
//////////////////////////////////////////////////////////////////////////////
function SquGetApi: PAPI; stdcall;

function SquOpenArea(pszPath: PAnsiChar; fOpenMode: UINT; fl: ULONG; var pnetAddr: NETADDR): TAreaHandle; stdcall;

function SquCloseArea(harea: TAreaHandle): BOOL; stdcall;
function SquLockArea(harea: TAreaHandle; bLock: BOOL): BOOL; stdcall;

function SquValidateMsg(harea: TAreaHandle; msgn: TMsgNumber; pimsg: PULONG): BOOL; stdcall;
function SquCreateMsgMap(harea: TAreaHandle; var paumsg: PUMSG; var pcumsg: ULONG): BOOL; stdcall;
function SquEnumMsgs(harea: TAreaHandle; pfnCallback: PFNENUMMSGS; pvCallbackData: Pointer; fl: ULONG): BOOL; stdcall;

function SquDeleteMsg(harea: TAreaHandle; msgn: TMsgNumber): BOOL; stdcall;
function SquSetCurMsg(harea: TAreaHandle; msgn: TMsgNumber): BOOL; stdcall;
function SquGetCurMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function SquGetFirstMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function SquGetHighMsg(harea: TAreaHandle): TMsgNumber; stdcall;
function SquGetMsgCount(harea: TAreaHandle): LONG; stdcall;

function SquMsgnToUid(harea: TAreaHandle; msgn: TMsgNumber): UMSG; stdcall;
function SquUidToMsgn(harea: TAreaHandle; umsg: UMSG; fMode: UINT): TMsgNumber; stdcall;

function SquOpenMsg(harea: TAreaHandle; mode: UINT; msgn: TMsgNumber; fl: ULONG): TMsgHandle; stdcall;
function SquCloseMsg(hmsg: TMsgHandle): BOOL; stdcall;

function SquLoadMsg(hmsg: TMsgHandle; var ppfmm: PFMM; fl: ULONG): BOOL; stdcall;
function SquSaveMsg(hmsg: TMsgHandle; pfmm: PFMM; fl: ULONG; cchTextTotal: ULONG): BOOL; stdcall;

function SquReadMsg(hmsg: TMsgHandle; psmh: PSMH; var ppchCtrl: PAnsiChar; pcchCtrl: PULONG;
  var ppchText: PAnsiChar; pcchText: PULONG; poffText: PULONG): BOOL; stdcall;

function SquWriteMsg(hmsg: TMsgHandle; psmh: PSMH; pchCtrl: PAnsiChar; cchCtrl: ULONG;
  pchText: PAnsiChar; cchText: ULONG; poffText: PULONG; cchTextTotal: ULONG): BOOL; stdcall;

function SquGetMsgCtrlLen(hmsg: TMsgHandle; var pcchCtrl: ULONG): BOOL; stdcall;
function SquGetMsgTextLen(hmsg: TMsgHandle; var pcchText: ULONG): BOOL; stdcall;

function SquGetLRInfo(harea: TAreaHandle; uid: ULONG; plri: PLRINFO): BOOL; stdcall;
function SquSetLRInfo(harea: TAreaHandle; uid: ULONG; plri: PLRINFO; pszUserName: PChar): BOOL; stdcall;

//////////////////////////////////////////////////////////////////////////////
//  SQUAPIP
//////////////////////////////////////////////////////////////////////////////
function SquCheckArea(parea:PSAREA):BOOL; stdcall;
function SquCheckMsg(pmsg:PSMSG):BOOL; stdcall;
function SquCheckMsgReadMode(pmsg:PSMSG):BOOL; stdcall;
function SquCheckMsgWriteMode(pmsg:PSMSG):BOOL; stdcall;

function SquLockBase(parea:PSAREA; bLock:BOOL):BOOL; stdcall;
function SquEnterExclusive(parea:PSAREA):BOOL; stdcall;
function SquLeaveExclusive(parea:PSAREA):BOOL; stdcall;

function SquLoadSbh(parea:PSAREA):BOOL; stdcall;
function SquSaveSbh(parea:PSAREA):BOOL; stdcall;
function SquCheckSbh(parea:PSAREA):BOOL; stdcall;

function SquResetCurMsgCache(parea:PSAREA):BOOL; stdcall;
function SquSetCurMsgCache(pmsg:PSMSG):BOOL; stdcall;

function SquLoadSfh(parea:PSAREA; psfh:PSFH; lfm:LONG):BOOL; stdcall;
function SquSaveSfh(parea:PSAREA; psfh:PSFH; lfm:LONG):BOOL; stdcall;

function SquAddFrame(parea:PSAREA; plfm:PLONG; cbFrame:ULONG):BOOL; stdcall;
function SquGetFrame(parea:PSAREA; plfm:PLONG; msgn:TMsgNumber):BOOL; stdcall;
function SquSetNextFrame(parea:PSAREA; lfm:LONG; lfmNext:LONG):BOOL; stdcall;
function SquSetPrevFrame(parea:PSAREA; lfm:LONG; lfmPrev:LONG):BOOL; stdcall;

function SquCheckUsed(parea:PSAREA; lfm:LONG):BOOL; stdcall;
function SquAddUsed(parea:PSAREA; psfh:PSFH; lfm:LONG):BOOL; stdcall;
function SquDelUsed(parea:PSAREA; psfh:PSFH; lfm:LONG):BOOL; stdcall;

function SquCheckFree(parea:PSAREA; lfm:LONG):BOOL; stdcall;
function SquAddFree(parea:PSAREA; psfh:PSFH; lfm:LONG):BOOL; stdcall;
function SquDelFree(parea:PSAREA; psfh:PSFH; lfm:LONG):BOOL; stdcall;
function SquFindFree(parea:PSAREA; psfh:PSFH; plfm:PLONG; cbFrame:ULONG):BOOL; stdcall;

function SquGetOpenMsg(parea:PSAREA; msgn:TMsgNumber):PSMSG; stdcall;
function SquDelMsg(parea:PSAREA; msgn:TMsgNumber; psfh:PSFH; lfm:LONG):BOOL; stdcall;
function SquTrimBase(parea:PSAREA; bAdding:BOOL):BOOL; stdcall;

function SquLoadSmh(parea:PSAREA; psmh:PSMH; lfm:LONG):BOOL; stdcall;
function SquSaveSmh(parea:PSAREA; psmh:PSMH; lfm:LONG):BOOL; stdcall;
function SquGetSafeMsgCtrlLen(pmsg:PSMSG; pcbMsg,pcbCtrl:PULONG):BOOL; stdcall;

function SquBeginSqiCache(parea:PSAREA):BOOL; stdcall;
function SquEndSqiCache(parea:PSAREA):BOOL; stdcall;

function SquGetSqiCount(parea:PSAREA):ULONG; stdcall;

function SquGetSqi(parea:PSAREA; psqi:PSQI; msgn:TMsgNumber):BOOL; stdcall;
function SquSetSqi(parea:PSAREA; psqi:PSQI; msgn:TMsgNumber):BOOL; stdcall;
function SquDelSqi(parea:PSAREA; psqi:PSQI; msgn:TMsgNumber):BOOL; stdcall;
function SquAddSqi(parea:PSAREA; psqi:PSQI; var pmsgn:TMsgNumber):BOOL; stdcall;
function SquAppSqi(parea:PSAREA; psqi:PSQI; var pmsgn:TMsgnumber):BOOL; stdcall;

function SquSetBaseTrimming(parea:PSAREA; cmsgMax, cmsgSkip:ULONG;
										 keepDays:USHORT):BOOL; stdcall;

function SquGetHash(pchText:PCH; cchText:UINT):ULONG; stdcall;

function SquCheckBase(pszPath:PSZ):BOOL; stdcall;

{$ENDIF}

implementation

{$IFDEF FMA_STATIC_LINKAGE}

{$IFNDEF VIRTUALPASCAL}
uses CrtDll;
{$ENDIF}
//////////////////////////////////////////////////////////////////////////////
//  FMAAPI
//////////////////////////////////////////////////////////////////////////////
function FmaCreateMsg; external;
function FmaDestroyMsg; external;
function FmaDupeMsg; external;
function FmaDumpMsg; external;
function FmaGetFmp; external;
function FmaDelFmp; external;
function FmaDumpFmp; external;
function FmaAddFmp; external;
function FmaAddFmpFormatV; external;
function FmaGetFmpTextLen; external;
function FmaOpenArea; external;
function FmaCloseArea; external;
function FmaLockArea; external;
function FmaValidateMsg; external;
function FmaCreateMsgMap; external;
function FmaEnumMsgs; external;
function FmaDeleteMsg; external;
function FmaSetCurMsg; external;
function FmaGetCurMsg; external;
function FmaGetFirstMsg; external;
function FmaGetHighMsg; external;
function FmaGetMsgCount; external;
function FmaMsgnToUid; external;
function FmaUidToMsgn; external;
function FmaOpenMsg; external;
function FmaCloseMsg; external;
function FmaLoadMsg; external;
function FmaSaveMsg; external;
function FmaReadMsg; external;
function FmaWriteMsg; external;
function FmaGetMsgCtrlLen; external;
function FmaGetMsgTextLen; external;
function FmaGetLRInfo; external;
function FmaSetLRInfo; external;
function FmaRegisterApi; external;
function FmaInitialize; external;
function FmaTerminate; external;
function FmaGetVersion; external;
function FmaSetLastError; external;
function FmaGetLastError; external;
//////////////////////////////////////////////////////////////////////////////
//  FTSAPI
//////////////////////////////////////////////////////////////////////////////
function FtsGetApi; external;
function FtsOpenArea; external;
function FtsCloseArea; external;
function FtsLockArea; external;
function FtsValidateMsg; external;
function FtsCreateMsgMap; external;
function FtsEnumMsgs; external;
function FtsDeleteMsg; external;
function FtsSetCurMsg; external;
function FtsGetCurMsg; external;
function FtsGetFirstMsg; external;
function FtsGetHighMsg; external;
function FtsGetMsgCount; external;
function FtsMsgnToUid; external;
function FtsUidToMsgn; external;
function FtsOpenMsg; external;
function FtsCloseMsg; external;
function FtsLoadMsg; external;
function FtsSaveMsg; external;
function FtsReadMsg; external;
function FtsWriteMsg; external;
function FtsGetMsgCtrlLen; external;
function FtsGetMsgTextLen; external;
function FtsGetLRInfo; external;
function FtsSetLRInfo; external;
//////////////////////////////////////////////////////////////////////////////
//  FTSAPIP
//////////////////////////////////////////////////////////////////////////////
function FtsCheckArea; external;
function FtsCheckMsg; external;
function FtsSortMsgMap; external;
function FtsRescanArea; external;
function FtsAddMsg; external;
function FtsCheckBase; external;
//////////////////////////////////////////////////////////////////////////////
//  PKTAPI
//////////////////////////////////////////////////////////////////////////////
function PktGetApi; external;
function PktOpenArea; external;
function PktCloseArea; external;
function PktLockArea; external;
function PktValidateMsg; external;
function PktCreateMsgMap; external;
function PktEnumMsgs; external;
function PktDeleteMsg; external;
function PktSetCurMsg; external;
function PktGetCurMsg; external;
function PktGetFirstMsg; external;
function PktGetHighMsg; external;
function PktGetMsgCount; external;
function PktMsgnToUid; external;
function PktUidToMsgn; external;
function PktOpenMsg; external;
function PktCloseMsg; external;
function PktLoadMsg; external;
function PktSaveMsg; external;
function PktReadMsg; external;
function PktWriteMsg; external;
function PktGetMsgCtrlLen; external;
function PktGetMsgTextLen; external;
function PktGetLRInfo; external;
function PktSetLRInfo; external;
//////////////////////////////////////////////////////////////////////////////
//  PKTAPIP
//////////////////////////////////////////////////////////////////////////////
function PktCheckArea;external;
function PktCheckMsg;external;
function PktCheckMsgReadMode;external;
function PktCheckMsgWriteMode;external;
function PktLockBase;external;
function PktEnterExclusive;external;
function PktLeaveExclusive;external;
function PktSetEnd;external;
function PktRescanArea;external;
function PktLoadPbh; external;
function PktSavePbh; external;
function PktCheckPbh;external;
function PktResetCurMsgCache; external;
function PktSetCurMsgCache;	external;
function PktGetOpenMsg; external;
function PktLoadPmh;external;
function PktSavePmh;external;
function PktAddMsg;	external;
function PktDelMsg;	external;
function PktShrinkPkt; external;
function PktExpandPkt; external;
function PktCheckBase; external;
function PktSetNetAddr;	external;
function PktGetNetAddr;	external;
function PktSetPassword; external;
function PktCheckPassword;external;
//////////////////////////////////////////////////////////////////////////////
//  FMAUTI
//////////////////////////////////////////////////////////////////////////////
function FmaListAdd; external;
function FmaListDel; external;
function FmaListCount; external;
function FmaSkipSpaces; external;
function FmaTrimSpaces; external;
function FmaAllocString; external;
function FmaEqPsz; external;
function FmaEqPch; external;
function FmaCpyStrMax; external;
function FmaGetHash; external;
function FmaGetCrc32; external;

function FmaGetCrc32v(var v; cb: ULONG; crc: ULONG; bLowerCase: BOOL): ULONG;
begin
  Result := FmaGetCrc32(Addr(v), cb, crc, bLowerCase);
end;

function FmaAddLsz; external;
function FmaGetLsz; external;
function FmaDelLsz; external;
procedure FmaDelLszList; external;
function FmaAddDsz; external;
function FmaAddDszFormatV; external;
function FmaSetDsz; external;
function FmaSetDszFormatV; external;
function FmaFixDsz; external;
procedure FmaDelDsz; external;
function FmaScanNetAddr; external;
function FmaFormatNetAddr; external;
function FmaFormatDttm; external;
//////////////////////////////////////////////////////////////////////////////
//  FMACTRL
//////////////////////////////////////////////////////////////////////////////
function FmaGetNetAddr; external;
function FmaLoadMhdr; external;
function FmaSaveMhdr; external;
function FmaLoadFLAGS; external;
function FmaLoadKludge; external;
function FmaSaveKludge; external;
function FmaLoadAddrKludges; external;
function FmaSaveAddrKludges; external;
function FmaLoadEomKludges; external;
function FmaSaveEomKludges; external;
function FmaGetFlagFromAttr; external;
function FmaGetAttrFromFlag; external;
function FmaGetKludgeFromId; external;
function FmaGetKludgeFromString;external;
function FmaGetEomKludgeFromId;external;
function FmaGetEomKludgeFromString; external;
function FmaAddAutoMSGID; external;
function FmaAddAutoPID; external;
function FmaAddAutoProp;  external;
//////////////////////////////////////////////////////////////////////////////
//  FMASYS
//////////////////////////////////////////////////////////////////////////////
function FmaMemAlloc; external;
function FmaMemRealloc; external;
procedure FmaMemFree; external;
function FmaOpenFile; external;
function FmaCloseFile; external;
function FmaReadFile; external;
function FmaWriteFile; external;
function FmaGetFilePos; external;
function FmaSetFilePos; external;
function FmaGetFileSize; external;
function FmaSetFileSize; external;
function FmaLock; external;
function FmaDeleteFile; external;
function FmaEnumFiles; external;
function FmaFileExists; external;
function FmaDirExists; external;
function FmaMakeDir; external;
procedure FmaInterlockedIncrement; external;
procedure FmaInterlockedDecrement; external;
function FmaGetLocalDttm; external;
function FmaGetLocalTime; external;
procedure FmaSleep; external;
function FmaGetMsgIdStamp; external;
function FmaQueryOSType; external;
procedure FmaGiveOutTimeSlice; external;
//////////////////////////////////////////////////////////////////////////////
//  JAMAPI
//////////////////////////////////////////////////////////////////////////////
function JamGetApi; external;
function JamOpenArea; external;
function JamCloseArea; external;
function JamLockArea; external;
function JamValidateMsg; external;
function JamCreateMsgMap; external;
function JamEnumMsgs; external;
function JamDeleteMsg; external;
function JamSetCurMsg; external;
function JamGetCurMsg; external;
function JamGetFirstMsg; external;
function JamGetHighMsg; external;
function JamGetMsgCount; external;
function JamMsgnToUid; external;
function JamUidToMsgn; external;
function JamOpenMsg; external;
function JamCloseMsg; external;
function JamLoadMsg; external;
function JamSaveMsg; external;
function JamReadMsg; external;
function JamWriteMsg; external;
function JamGetMsgCtrlLen; external;
function JamGetMsgTextLen; external;
function JamGetLRInfo; external;
function JamSetLRInfo; external;
//////////////////////////////////////////////////////////////////////////////
//  JAMAPIP
//////////////////////////////////////////////////////////////////////////////
function JamCheckArea; external;
function JamCheckMsg; external;
function JamCheckMsgReadMode; external;
function JamCheckMsgWriteMode; external;
function JamLockBase; external;
function JamEnterExclusive; external;
function JamLeaveExclusive; external;
function JamLoadJbh; external;
function JamSaveJbh; external;
function JamCheckJbh; external;
function JamResetCurMsgCache;external;
function JamSetCurMsgCache;external;
function JamGetOpenMsg;external;
function JamCheckLmh;external;
function JamLoadJmh;external;
function JamSaveJmh;external;
function JamGetJsf;external;
function JamDelJsf;external;
function JamAddJsf;external;
//function _JamAddJsfFormat; external;
function JamAddJsfFormatV;external;
function JamBeginJdxCache;external;
function JamEndJdxCache;external;
function JamGetJdxCount;external;
function JamGetJdx;external;
function JamSetJdx;external;
function JamDelJdx;external;
function JamAddJdx;external;
function JamGetCrc32;external;
function JamGetJlr;external;
function JamSetJlr;external;
function JamCheckBase;external;
function JamSetPassword;external;
function JamCheckPassword;external;
//////////////////////////////////////////////////////////////////////////////
//  SQUAPI
//////////////////////////////////////////////////////////////////////////////
function SquGetApi; external;
function SquOpenArea;external;
function SquCloseArea;external;
function SquLockArea;external;
function SquValidateMsg;external;
function SquCreateMsgMap;external;
function SquEnumMsgs;external;
function SquDeleteMsg;external;
function SquSetCurMsg;external;
function SquGetCurMsg;external;
function SquGetFirstMsg;external;
function SquGetHighMsg;external;
function SquGetMsgCount;external;
function SquMsgnToUid;external;
function SquUidToMsgn;external;
function SquOpenMsg;external;
function SquCloseMsg;external;
function SquLoadMsg;external;
function SquSaveMsg;external;
function SquReadMsg;external;
function SquWriteMsg;external;
function SquGetMsgCtrlLen;external;
function SquGetMsgTextLen;external;
function SquGetLRInfo;external;
function SquSetLRInfo;external;
//////////////////////////////////////////////////////////////////////////////
//  SQUAPIP
//////////////////////////////////////////////////////////////////////////////
function SquCheckArea; external;
function SquCheckMsg; external;
function SquCheckMsgReadMode; external;
function SquCheckMsgWriteMode; external;
function SquLockBase; external;
function SquEnterExclusive; external;
function SquLeaveExclusive; external;
function SquLoadSbh; external;
function SquSaveSbh; external;
function SquCheckSbh; external;
function SquResetCurMsgCache; external;
function SquSetCurMsgCache; external;
function SquLoadSfh; external;
function SquSaveSfh; external;
function SquAddFrame; external;
function SquGetFrame; external;
function SquSetNextFrame; external;
function SquSetPrevFrame; external;
function SquCheckUsed; external;
function SquAddUsed; external;
function SquDelUsed; external;
function SquCheckFree; external;
function SquAddFree; external;
function SquDelFree; external;
function SquFindFree; external;
function SquGetOpenMsg; external;
function SquDelMsg; external;
function SquTrimBase; external;
function SquLoadSmh; external;
function SquSaveSmh; external;
function SquGetSafeMsgCtrlLen; external;
function SquBeginSqiCache; external;
function SquEndSqiCache; external;
function SquGetSqiCount; external;
function SquGetSqi; external;
function SquSetSqi; external;
function SquDelSqi; external;
function SquAddSqi; external;
function SquAppSqi; external;
function SquSetBaseTrimming; external;
function SquGetHash; external;
function SquCheckBase; external;

{$ENDIF}

end.