unit uFidoWrite;
/////////////////////////////////////////////////////////////////////////////
//     FMA Express
//   WriteNetmail  WriteEchoMail --     
//  , , NetMail (MSG-)    
// .
//
//   (c)   , 2002
/////////////////////////////////////////////////////////////////////////////
interface
uses Classes, uFidoCommon;

//   NetMail'
{
  NetPath --     *.msg 
  fromAddress, fromName --     
  toAddress, toName     --    ,   
  Subject --  
  Info    --  
}
procedure WriteNetmail(const NetPath, fromAddress, fromName,
          toAddress, toName, Subject: string; Info: TStrings);

//    
{
  EchoType --   (. uFidoCommon)
  EchoPath --   /    
  fromAddress, fromName --     
  toAddress, toName     --    ,   
  Subject --  
  Info    --  
}
procedure WriteEchoMail(EchoType: TBaseType; const EchoPath, fromAddress,
          fromName, toAddress, toName, Subject: string; Info: TStrings);

implementation
uses SysUtils, FmaAPI, FmxAPI, FmxCore, FmxFts, uFidoRoutine;

// ""  --   WriteNetmail  WriteEchoMail
{
  Area     -- - TFmxCustomMessageArea;  
                
  AreaPath --  /      ""
  fromAddress, fromName --     
  toAddress, toName     --    ,   
  Subject --  
  Attribs --  
  Info    --  
}
procedure WriteAreaMsg(Area: TFmxCustomMessageArea;
  const AreaPath, fromAddress, fromName, toAddress, toName, Subject: string;
  const Attribs: TFmxMsgAttributes; Info: TStrings);
var
  userAddr: TFmxNetAddr;
  NewMessage: TFmxCustomAreaMessage;
  MessageObject : TFmxMessageObject;
begin
 //  fromAddress,   
 ExplodeAddress(fromAddress,
                userAddr.zone, userAddr.net, userAddr.node, userAddr.point);
 //      
 Area.Path := AreaPath;
 Area.NetAddr := userAddr;
 Area.OpenMode := aomExisting;
 Area.Open;
 //   
 NewMessage := Area.GetMessage(0, momCreate, []);
 try
   //    
   MessageObject := TFmxMessageObject.CreateNew(0);
   try
     //     
     with MessageObject do
      begin
       Attributes := Attribs;
       AddDTMProperty(FMP_DTTMWRITTEN, Now);
       AddStringProperty(FMP_SENDERNAME, fromName);
       AddStringProperty(FMP_ORIGADDR,   fromAddress);
       AddStringProperty(FMP_RECEVRNAME, toName);
       AddStringProperty(FMP_DESTADDR,   toAddress);
       AddStringProperty(FMP_SUBJECT,    Subject);
       AddStringsProperty(FMP_MESSAGETEXT, Info);
      end;
     //  
     NewMessage.Save(MessageObject.DataPointer, FSM_AUTOMSGID or FSM_AUTOPID);
   finally
     NewMessage.Close;
     MessageObject.Free;
   end;
 finally
   NewMessage.Free;
   Area.Close;
 end;
end;


procedure WriteNetmail(const NetPath, fromAddress, fromName,
          toAddress, toName, Subject: string; Info: TStrings);
var NetArea: TFmxFtsMessageArea;
begin
  NetArea := TFmxFtsMessageArea.Create;
  try
    WriteAreaMsg(NetArea, NetPath, fromAddress, fromName, toAddress, toName,
            Subject, [maLocal, maForcePickup, maPrivate, maKillSent], Info);
  finally
    NetArea.Free
  end;
end;


procedure WriteEchoMail(EchoType: TBaseType; const EchoPath, fromAddress,
          fromName, toAddress, toName, Subject: string; Info: TStrings);
var EchoArea: TFmxCustomMessageArea;
begin
  EchoArea := AreaClasses[EchoType].Create;
  try
    WriteAreaMsg(EchoArea, EchoPath, fromAddress, fromName, toAddress, toName,
              Subject, [maLocal, maForcePickup, maKillSent], Info);
  finally
    EchoArea.Free;
  end;
end;
end.
