unit FmxDef;
/////////////////////////////////////////////////////////////////////////////
//
// Fidonet Mail Access: FmaDef Utilities that references Delphi functionality
//
// FmxDef.Pas
//
// Copyright (c) 1999-2000 by Pete Kvitek
// Convertion to Delphi's Object Pascal by Akzhan Abdulin
//                                         http://www.akzhan.midi.ru/fma/
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version. See GNU_GPL.TXT for details.
//
// Created: 14/Feb/2000
// Updated: 14/Feb/2000
//
// History: 14/Feb/2000 akzhan  - Initially created for Delphi convertion.
//
/////////////////////////////////////////////////////////////////////////////

interface

uses
  FmaDef, SysUtils;

type
  TFmxNetAddr = TFmaNetAddr;

type
  EInvalidArgument = class(Exception)
  end;

function DTTMtoDateTime(dttm: DTTM): TDateTime;
function DateTimeToDTTM(DateTime: TDateTime): DTTM;

implementation

function DTTMtoDateTime(dttm: DTTM): TDateTime;
var
  Sec: Word;
  Min: Word;
  Hour: Word;
  Day: Word;
  Month: Word;
  Year: Word;
begin
  DecodeDTTM(dttm, Sec, Min, Hour, Day, Month, Year);
  Result := EncodeDate(Year, Month, Day) + EncodeTime(Hour, Min, Sec, 0);
end;

function DateTimeToDTTM(DateTime: TDateTime): DTTM;
var
  MSec: Word;
  Sec: Word;
  Min: Word;
  Hour: Word;
  Day: Word;
  Month: Word;
  Year: Word;
begin
  DecodeDate(DateTime, Year, Month, Day);
  DecodeTime(DateTime, Hour, Min, Sec, MSec);
  if MSec >= 500 then Inc(Sec);
  Result := EncodeDTTM(Sec, Min, Hour, Day, Month, Year);
end;

end.
