unit FmxRes;

interface

uses
  FmaDef, FmaApi;

function FmxGetErrorDescription(ErrorCode: TFmaError): AnsiString;

implementation

{$IFNDEF VIRTUALPASCAL}
{$WRITEABLECONST OFF}
{$ENDIF}
const
  FmaErrorDescriptions: array [FMAERROR_NONE..FMAERROR_DATA_SIZE_LIMIT + 1] of AnsiString = (
    'No error',
    'Internal error occurred.',
    'Requested feature or item is not currently supported.',
    'Invalid parameter passed to the function.',
    'Invalid data detected. This could be result of corrupted message base or invalid information passed by the caller.',
    'Invalid data size detected. This could be result of corrupted message base or invalid information passed by the caller.',
    'There is not enough memory for the requested operation.',
    'Request item not found. This could be message base, message with the specified number, etc.',
    'Request item already exists.',
    'Messages or areas are still open when closing area or the entire API respectively.',
    'Failed to create request item. This could be message base, message, etc.',
    'Failed to open item. This could be message base, message, file.',
    'Seek failed. This error usually relates to file operations and indicates severe file related problem.',
    'Read failed. This error usually relates to file operations and indicates severe file related problem.',
    'Write failed. This error usually relates to file operations and indicates severe file related problem.',
    'Delete failed. This could be message, file, property, etc.',
    'Lock failed. The file or message base may be in use by other process.',
    'Unlock failed. This error usually relates to file operations and indicates severe file related problem.',
    'Disk full when writing message or file.',
    'Attempt to unlock message base or file which is not locked.',
    'Attempt to leave exclusive mode when it is not currently in effect.',
    'Attempt to stop caching mode when it is not currently in effect.',
    'Attempt to read frame that is currently updated by another process.',
    'Invalid message frame detected. This error is usually result of corrupted message base.',
    'Invalid index entry detected. This error is usually result of corrupted message base index file.',
    'File or message base is in use by other process.',
    'Missing some of the message base files.',
    'Detected incorrectly formatted network address.',
    'Detected incorrectly formatted message kludge.',
    'Detected incorrectly specified user id. This error is a result of un-even user id specification when an area is opened in FOA_HIGHREAD flag.',
    'Item is not registered. This could be message base api, etc.',
    'Item is too large to process. This could be message contol info, message text, etc in 16-bit builds of the toolkit.',
    'Custom error.'
  );

function FmxGetErrorDescription(ErrorCode: TFmaError): AnsiString;
begin
 if {(ErrorCode >= FMAERROR_NONE) and} (ErrorCode <= FMAERROR_DATA_SIZE_LIMIT) then
 begin
   Result := FmaErrorDescriptions[ErrorCode];
 end
 else
 begin
   Result := FmaErrorDescriptions[FMAERROR_DATA_SIZE_LIMIT + 1];
 end;
end;

end.
