unit FtsApiP;
/////////////////////////////////////////////////////////////////////////////
//
// Fidonet Mail Access: Fts api private declarations module
//
// FtsApiP.h
//
// Copyright (c) 1999-2000 by Pete Kvitek
// Convertion to Object Pascal by Eugene Kotlyarov 
//                                http://ekot.narod.ru/fma/
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version. See GNU_GPL.TXT for details.
//
// Created: 27/Aug/1999
// Updated: 13/Jan/2001
//
// History: 27/Aug/1999 kvitekp - Initially created.
//
//          13/Jan/2001 eugene  - Conversion completed.
/////////////////////////////////////////////////////////////////////////////
//
// NOTE: STRUCTURES PACKING MUST BE THE SAME AS IN FMA!!
//
/////////////////////////////////////////////////////////////////////////////
interface
uses Windows, FmaDef, FmaApi, FtsApi;
/////////////////////////////////////////////////////////////////////////////
// Fts area declarations
/////////////////////////////////////////////////////////////////////////////
type
  // Forward declarations
  PSZ=PAnsiChar;
  PFMSG=^_FMSG;

  // Fts message area object structure

  _FAREA = record        (* area *)
	magic	:ULONG;                  // Magic number (FAREA_MAGIC)
	papi	:PAPI;                   // Fts api pointer
	cmsg	:ULONG;                  // Number of messages
	msgnCur	:TMsgNumber;             // Current message number
	msgnHigh:TMsgNumber;             // Highest message number
	aumsg	:^UINT;                  // Message numbers array
	cumsg	:UINT;                   // Message numbers array size
	bAreaLocked:BOOL;                // Area lock count
	fl		:ULONG;                  // Open area flags (FOA_)
	pmsgList:PFMSG;                  // Open messges list
	netAddr	:NETADDR;                // Default network address
	achPath	:packed array[0..0] of CHAR;    // Area path (asciiz)
  end;
  FAREA=_FAREA;
  PFAREA=^_FAREA;

  // Fts message object structure

  _FMSG = record         (* msg *)
	pmsgPrev:PFMSG;            // Pointer to prev open msg in area
	pmsgNext:PFMSG;            // Pointer to next open msg in area
	magic	:ULONG;            // Magic number (FMSG_MAGIC)
	parea	:PFAREA;           // Message area handle
	msgn	:TMsgNumber;       // Message number
	mode	:UINT;             // Message open mode
	fl		:ULONG;            // Message open flags (FOM_)
	pszCtrl	:PSZ;              // Message control info
	cchCtrl	:UINT;             // Message control info length
	fmh		:FMH;              // Message header
	fs		:UINT;             // Message status flags (FMF_)
	lmt		:LONG;             // Message text offset
	lmtEnd	:LONG;             // Message text end offset
	lmtMax	:LONG;             // Message text max offset
	hfile	:HFILE;            // Message file handle
  end;

  // Fts message area object magic number
const FAREA_MAGIC = $45524146; // Long equivalent of "FARE"

  // Fts message object magic number
const FMSG_MAGIC  =$47534D46;  // Long equivalent of "FMSG"

  // Fts message status flags in msg.fs

const FMF_GOTMSGH       =$0001;        // Message header has been associated
const FMF_GOTCTRL       =$0002;        // Control info has been associated
const FMF_BOGUS         =$0004;        // -- reserved
const FMF_GOTFRAME      =$0008;        // Writing frame selected for new message
const FMF_MSGHWRITTEN   =$0100;        // Message header has been written
const FMF_CTRLWRITTEN   =$0200;        // Message contrl info has been written
const FMF_TEXTWRITTEN   =$0400;        // Message text has been written
const FMF_CTRLHASAREA   =$1000;        // Message contrl info has AREA w/o ^a

  // Message has been written to mask

const FMF_MASKWRITTEN  = (FMF_MSGHWRITTEN OR FMF_CTRLWRITTEN OR FMF_TEXTWRITTEN);

{$IFNDEF FMA_STATIC_LINKAGE}
function FtsCheckArea(parea:PFAREA):BOOL;stdcall;
function FtsCheckMsg(pmsg:PFMSG):BOOL; stdcall;
function FtsSortMsgMap(parea:PFAREA):BOOL; stdcall;
function FtsRescanArea(parea:PFAREA):BOOL; stdcall;
function FtsAddMsg(parea:PFAREA;msgn:TMsgNumber):BOOL; stdcall;
function FtsCheckBase(pszPath:PSZ):BOOL; stdcall;
{$ENDIF}
implementation
{$IFNDEF FMA_STATIC_LINKAGE}
function FtsCheckArea; external FmaDll;
function FtsCheckMsg; external FmaDll;
function FtsSortMsgMap; external FmaDll;
function FtsRescanArea; external FmaDll;
function FtsAddMsg; external FmaDll;
function FtsCheckBase; external FmaDll;
{$ENDIF}
end.