unit crtdll;
/////////////////////////////////////////////////////////////////////////////
//
// crtdll.dll Pascal interface (partial)
//
// crtdll.pas
//
// Copyright (c) 2001 by Eugene Kotlyarov http://ekot.narod.ru/delphi/
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version. See GNU_GPL.TXT for details.
//
// Created: 03/Jan/2001
// Updated: 03/Jan/2001
//
// History: 03/Jan/2001 eugene - Initially created for FMA/Fmx.
//
/////////////////////////////////////////////////////////////////////////////
interface

const
  CRTDLLname='crtdll.dll';

type 
   size_t=integer;
   long  =integer;
   int   =integer;
   time_t=long;
   cFILE =pointer;
   Tfcmp =function(p1,p2:pointer):int;cdecl;

procedure _errno;cdecl;// variable

function _malloc(size:size_t):pointer;cdecl;   
function _realloc(block:pointer;size:size_t):pointer;cdecl;
procedure _free(block:pointer);cdecl;     

function _atol(s:PChar):long;cdecl;     
function _sopen(s:PChar;i1,i2:int{;...}):int;cdecl;    
function _close(handle:int):int;cdecl;
function _tell(handle:int):long;cdecl;
function _lseek(handle:int;offset:long;fromwhere:int):long;cdecl;
function _filelength(handle:int):long;cdecl;
function _chsize(handle:int;size:long):int;cdecl;
function _read(handle:int;buf:pointer;len:long):int;cdecl;
function _write(handle:int;buf:pointer;len:long):int;cdecl;
function _locking(handle,cmd,length:int):int;cdecl;
function _mkdir(path:PChar):int;cdecl;
function _unlink(s:PChar):int;cdecl;
function _time(var timer:time_t):time_t;cdecl;
function _getenv(name:PChar):PChar;cdecl;
function _fopen(filename,mode:PChar):cFILE;cdecl;
function _fclose(f:cFILE):int;cdecl;
function _fputs(s:PChar;f:cFILE):int;cdecl;
function _fflush(stream:cFILE):int;cdecl;

function _bsearch(key,base:pointer;nelem,width:size_t;fcmp:Tfcmp):pointer;cdecl;
procedure _qsort(base:pointer;nelem,width:size_t;fcmp:Tfcmp);cdecl;

function _memchr(s:pointer;c:int;n:size_t):pointer;cdecl;
function _memcmp(s1,s2:pointer;n:size_t):int;cdecl;
function _memcpy(dest,src:pointer;n:size_t):pointer;cdecl;
function _memmove(dest,src:PChar;n:size_t):pointer;cdecl;
function _memset(s:pointer;c:int;n:size_t):pointer;cdecl;
function _strcat(dest,src:PChar):PChar;cdecl;
function _strchr(s:PChar;c:int):PChar;cdecl;   
function _strlen(s:PChar):size_t;cdecl;
function _strncpy(dest,src:PChar;maxlen:size_t):PChar;cdecl;
function _strrchr(s:PChar;c:size_t):PChar;cdecl;
implementation

procedure _errno;    
  external CRTDLLname name '_errno';

function  _memcpy;
  external CRTDLLname name 'memcpy';
function  _memset;   
  external CRTDLLname name 'memset';
function  _strlen;
  external CRTDLLname name 'strlen';
function  _strchr;   
  external CRTDLLname name 'strchr';
function  _atol;     
  external CRTDLLname name 'atol';
function  _malloc;   
  external CRTDLLname name 'malloc';
procedure _free;     
  external CRTDLLname name 'free';
function  _realloc;  
  external CRTDLLname name 'realloc';
function  _time;
  external CRTDLLname name 'time';
function  _strncpy;
  external CRTDLLname name 'strncpy';
function  _bsearch;
  external CRTDLLname name 'bsearch';
function _memmove;
  external CRTDLLname name 'memmove';
procedure _qsort;
  external CRTDLLname name 'qsort';
function _strcat;
  external CRTDLLname name 'strcat';
function _memcmp;        
  external CRTDLLname name 'memcmp';
function _strrchr;
  external CRTDLLname name 'strrchr';
function _memchr;
  external CRTDLLname name 'memchr';

function _sopen;    
  external CRTDLLname name '_sopen';
function  _close;    
  external CRTDLLname name '_close';
function  _tell;     
  external CRTDLLname name '_tell';
function  _lseek;    
  external CRTDLLname name '_lseek';
function  _filelength;
  external CRTDLLname name '_filelength';
function  _chsize;   
  external CRTDLLname name '_chsize';
function  _read;     
  external CRTDLLname name '_read';
function  _write;    
  external CRTDLLname name '_write';
function  _locking;  
  external CRTDLLname name '_locking';
function  _unlink;   
  external CRTDLLname name '_unlink';
function  _mkdir;    
  external CRTDLLname name '_mkdir';
function _getenv;
  external CRTDLLname name 'getenv';
function _fopen;
  external CRTDLLname name 'fopen';
function _fclose;
  external CRTDLLname name 'fclose';
function _fputs;
  external CRTDLLname name 'fputs';
function _fflush;
  external CRTDLLname name 'fflush';

end.